package de.akquinet.jbosscc.examples.eap.dynamic;

import de.akquinet.jbosscc.examples.eap.ejb.BatchService;
import javax.ejb.EJB;
import javax.enterprise.inject.Model;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import java.util.List;

@Model
public class WebController {
    @EJB
    private BatchService batchService;

    private String batchJobName;

    private final static String RESPONSE = "index";

    public String submitBatch() {
        batchService.submitBatch(getBatchJobName());

        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
            "Batch job submitted", null));

        return RESPONSE;
    }

    public List<String> getJobs() {
        return batchService.listJobs();
    }

    public String submitBatchToJms() {
        batchService.submitBatchToJms(getBatchJobName());
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
            "JMS job submitted", null));
        return RESPONSE;
    }

    public String getBatchJobName() {
        return batchJobName;
    }

    public void setBatchJobName(final String batchJobName) {
        this.batchJobName = batchJobName;
    }
}
