package de.akquinet.jbosscc.examples.eap.jms;

import de.akquinet.jbosscc.examples.eap.Resources;
import de.akquinet.jbosscc.examples.eap.bean.BatchJob;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.transaction.TransactionManager;
import java.util.logging.Level;
import java.util.logging.Logger;

@MessageDriven(activationConfig = {@ActivationConfigProperty(propertyName = "destinationLookup",
    propertyValue = Resources.Queue), @ActivationConfigProperty(propertyName = "destinationType",
    propertyValue = "javax.jms.Queue"),})
public class BatchProcessor implements MessageListener {
    private static final Logger LOGGER = Logger.getLogger(BatchProcessor.class.getName());

    @Resource
    private TransactionManager transactionManager;


    @Override
    public void onMessage(final Message message) {
        try {
            final ObjectMessage omsg = (ObjectMessage) message;
            final BatchJob batchJob = (BatchJob) omsg.getObject();

            LOGGER.info("JMS executing " + batchJob.getName());

            batchJob.work();
        } catch (final Exception e) {
            LOGGER.log(Level.SEVERE, "batch job", e);
        }
    }
}
